CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  cols = vgatext#cols
  rows = vgatext#rows
  chrs = cols * rows


OBJ
  vgatext : "JB_Mod_vga_hires_text"
  key     : "keyboard"

VAR

  'sync long - written to -1 by VGA driver after each screen refresh
  long  sync
  'screen buffer - could be bytes, but longs allow more efficient scrolling
  byte  screen[chrs]
  'row colors
  word  colors[rows]
  byte  cx,cy
  word  px,py,pmode
  byte  mykey
  long  counter
  long  bit1,bit2,bit3

PUB start | i, j

  vgatext.start(16, @screen, @colors, 0, @sync)

  key.start(26, 27)

  repeat i from 0 to rows-1
    colors[i]:=%%00103300

' fill screen with "A" characters    
  repeat i from 0 to chrs - 1
    screen.byte[i] := "a"

'draw line around edge of screen and diagonals and cross in middle
  repeat i from 0 to 255
    plot(i,0)
    plot(i,(i*192)>>8)
    plot(255-i,(i*192)>>8)
    plot(i,191)
    plot(i,95)
  repeat i from 0 to 191
    plot(0,i)
    plot(127,i)
    plot(255,i)

  print(20,0,string("HELLO world")) ' caps = blue on yellow, lowercase = yellow on blue.

  plotprint(4,78,string("HELLO world")) ' caps = blue on yellow, lowercase = yellow on blue.

  'main loop - if key pressed display on screen
  repeat
    waitcnt(clkfreq/50+cnt)
     
    mykey := key.key

    if mykey
      screen.byte[cy * cols + cx] := mykey
      cx := cx + 1
      if cx > cols - 1
        cx := 0
        cy := cy + 1
        if cy > rows - 1
          cy := 0
      
pub plot(x,y) | s,p
  if x=>0 and x<256 and y=>0 and y<192 'comment out this line to speed it up, if you know you're not going to go outside the screen area :)
    s:=@screen+((y>>1)*cols)+(x>>1)
    if byte[s][0]>15
      byte[s][0]:=0
    p:=((x&1)+1)<<((y&1)<<1)
    byte[s][0]|=p

pub print(x,y,s)
  repeat while byte[s][0]
    screen[y*cols+x]:=byte[s][0]
    s++
    x++

pub plotprint(x,y,s)
  repeat while byte[s][0]
    plotprintchar(x,y,byte[s][0])
    s++
    x+=8

pub plotprintchar(x,y,c) | tx,ty,fp
  fp:=vgatext.getfont+(c*4)
  repeat ty from 0 to 7
    repeat tx from 0 to 7
      if ( byte[fp][(ty&3)+((ty&4)<<7)] & (|<tx) )
        plot(x+tx,y+ty)
      
                        